<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1, shrink-to-fit=no"
    />
    <meta name="description" content="" />
    <meta name="author" content="" />

    <title></title>

    <!-- Custom fonts for this template-->

    <link
      href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i"
      rel="stylesheet"
    />

    <!-- Custom styles for this template-->
    <link href="css/sb-admin-2.min.css" rel="stylesheet" />
    <link
      href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.13.0/css/all.min.css"
      rel="stylesheet"
      type="text/css"
    />
    <link
      href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i"
      rel="stylesheet"
    />

    <link
      href="https://cdn.jsdelivr.net/npm/startbootstrap-sb-admin-2@4.0.7/css/sb-admin-2.min.css"
      rel="stylesheet"
    />
    <link
      rel="stylesheet"
      type="text/css"
      href="https://cdn.datatables.net/v/dt/jszip-2.5.0/dt-1.12.1/b-2.2.3/b-colvis-2.2.3/b-html5-2.2.3/b-print-2.2.3/cr-1.5.6/fh-3.2.4/kt-2.7.0/r-2.3.0/rg-1.2.0/rr-1.2.8/sc-2.0.7/sb-1.3.4/sp-2.0.2/sl-1.4.0/datatables.min.css"
    />
  </head>

  <body id="page-top">
    <!-- Page Wrapper -->
    <div id="wrapper">
      <!-- Sidebar -->
      <ul
        class="navbar-nav bg-gradient-primary sidebar sidebar-dark accordion"
        id="accordionSidebar"
      >
        <!-- Sidebar - Brand -->
        <a
          class="sidebar-brand d-flex align-items-center justify-content-center"
          href="index.html"
        >
          <div class="sidebar-brand-icon rotate-n-15">
            <img src="img/logo.png" width="20" />
          </div>
          <div class="sidebar-brand-text mx-3">dsplus<sup></sup></div>
        </a>

        <!-- Divider -->
        <hr class="sidebar-divider my-0" />

        <!-- Nav Item - Dashboard -->
        <li class="nav-item">
          <a class="nav-link" href="index.html">
            <i class="fas fa-fw fa-tachometer-alt"></i>
            <span>Dashboard</span></a
          >
        </li>

        <!-- Divider -->
        <hr class="sidebar-divider" />

        <!-- Heading -->

        <!-- Heading -->

        <!-- Nav Item - Projects Collapse Menu -->
        <li class="nav-item active">
          <a
            class="nav-link"
            href="#"
            data-toggle="collapse"
            data-target="#collapseProjects"
            aria-expanded="true"
            aria-controls="collapseProjects"
          >
            <i class="fas fa-fw fa-folder"></i>
            <span>Projects</span>
          </a>
          <div
            id="collapseProjects"
            class="collapse show"
            aria-labelledby="headingProjects"
            data-parent="#accordionSidebar"
          >
            <div
              class="bg-white py-2 collapse-inner rounded"
              id="projects"
            ></div>
          </div>
        </li>

        <!-- Divider -->
        <hr class="sidebar-divider d-none d-md-block" />

        <!-- Sidebar Toggler (Sidebar) -->
        <div class="text-center d-none d-md-inline">
          <button class="rounded-circle border-0" id="sidebarToggle"></button>
        </div>
      </ul>
      <!-- End of Sidebar -->

      <!-- Content Wrapper -->
      <div id="content-wrapper" class="d-flex flex-column">
        <!-- Main Content -->
        <div id="content">
          <!-- Topbar -->
          <nav
            class="navbar navbar-expand navbar-light bg-white topbar mb-4 static-top shadow"
          >
            <!-- Sidebar Toggle (Topbar) -->
            <button
              id="sidebarToggleTop"
              class="btn btn-link d-md-none rounded-circle mr-3"
            >
              <i class="fa fa-bars"></i>
            </button>

            <!-- Topbar Navbar -->
            <ul class="navbar-nav ml-auto">
              <!-- Nav Item - Search Dropdown (Visible Only XS) -->
              <li class="nav-item dropdown no-arrow d-sm-none">
                <a
                  class="nav-link dropdown-toggle"
                  href="#"
                  id="searchDropdown"
                  role="button"
                  data-toggle="dropdown"
                  aria-haspopup="true"
                  aria-expanded="false"
                >
                  <i class="fas fa-search fa-fw"></i>
                </a>
                <!-- Dropdown - Messages -->
                <div
                  class="dropdown-menu dropdown-menu-right p-3 shadow animated--grow-in"
                  aria-labelledby="searchDropdown"
                >
                  <form class="form-inline mr-auto w-100 navbar-search">
                    <div class="input-group">
                      <input
                        type="text"
                        class="form-control bg-light border-0 small"
                        placeholder="Search for..."
                        aria-label="Search"
                        aria-describedby="basic-addon2"
                      />
                      <div class="input-group-append">
                        <button class="btn btn-primary" type="button">
                          <i class="fas fa-search fa-sm"></i>
                        </button>
                      </div>
                    </div>
                  </form>
                </div>
              </li>
            </ul>
          </nav>
          <!-- End of Topbar -->

          <!-- Begin Page Content -->
          <div class="container-fluid">
            <!-- Page Heading -->
            <h1 class="h3 mb-4 text-gray-800" id="project"></h1>

            <div class="row">
              <div class="col-xl-3 col-md-6 mb-4">
                <div class="card border-left-info shadow h-100 py-2">
                  <div class="card-body">
                    <div class="row no-gutters align-items-center">
                      <div class="col mr-2">
                        <div
                          class="text-xs font-weight-bold text-info text-uppercase mb-1"
                        >
                          Assets
                        </div>
                        <div
                          class="h5 mb-0 font-weight-bold text-gray-800"
                          id="assets"
                        ></div>
                      </div>
                      <div class="col-auto">
                        <i class="fas fa-cubes fa-2x text-gray-300"></i>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
              <div class="col-xl-3 col-md-6 mb-4">
                <div class="card border-left-info shadow h-100 py-2">
                  <div class="card-body">
                    <div class="row no-gutters align-items-center">
                      <div class="col mr-2">
                        <div
                          class="text-xs font-weight-bold text-info text-uppercase mb-1"
                        >
                          Project Size
                        </div>
                        <div
                          class="h5 mb-0 font-weight-bold text-gray-800"
                          id="size"
                        ></div>
                      </div>
                      <div class="col-auto">
                        <i class="fas fa-weight fa-2x text-gray-300"></i>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
              <div class="col-xl-3 col-md-6 mb-4">
                <div class="card border-left-warning shadow h-100 py-2">
                  <div class="card-body">
                    <div class="row no-gutters align-items-center">
                      <div class="col mr-2">
                        <div
                          class="text-xs font-weight-bold text-warning text-uppercase mb-1"
                        >
                          Issues
                        </div>
                        <div
                          class="h5 mb-0 font-weight-bold text-gray-800"
                          id="issues"
                        ></div>
                      </div>
                      <div class="col-auto">
                        <i
                          class="fas fa-exclamation-circle fa-2x text-gray-300"
                        ></i>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>

            <div class="row">
              <div class="col-6">
                <!-- Area Chart -->

                <div class="card shadow mb-4">
                  <!-- Card Header - Dropdown -->
                  <div
                    class="card-header py-3 d-flex flex-row align-items-center justify-content-between"
                  >
                    <h6 class="m-0 font-weight-bold text-primary">Overview</h6>
                  </div>
                  <!-- Card Body -->
                  <div class="card-body">
                    <div style="height: 40vh">
                      <canvas class="chartjs" id="metricsChart"></canvas>
                    </div>
                  </div>
                </div>
              </div>

              <div class="col-6">
                <div class="card shadow mb-4">
                  <!-- Card Header - Dropdown -->
                  <div
                    class="card-header py-3 d-flex flex-row align-items-center justify-content-between"
                  >
                    <h6 class="m-0 font-weight-bold text-primary">Assets</h6>
                  </div>
                  <!-- Card Body -->
                  <div class="card-body">
                    <div style="height: 40vh">
                      <canvas class="chartjs" id="objectsChart"></canvas>
                    </div>
                  </div>
                </div>
              </div>
            </div>

            <div class="row">
              <div class="col-sm-2 mb-4 d-none" id="blocker">
                <div class="card border-left-danger shadow h-100 py-2">
                  <div class="card-body">
                    <div class="row no-gutters align-items-center">
                      <div class="col mr-2">
                        <div
                          class="text-xs font-weight-bold text-success text-uppercase mb-1"
                        >
                          Blocker
                        </div>
                        <div
                          class="h5 mb-0 font-weight-bold text-gray-800"
                          id="cblocker"
                        ></div>
                      </div>
                      <div class="col-auto">
                        <i class="fas fa-radiation fa-2x text-gray-300"></i>
                      </div>
                    </div>
                  </div>
                </div>
              </div>

              <div class="col-sm-2 mb-4 d-none" id="critical">
                <div class="card border-left-danger shadow h-100 py-2">
                  <div class="card-body">
                    <div class="row no-gutters align-items-center">
                      <div class="col mr-2">
                        <div
                          class="text-xs font-weight-bold text-success text-uppercase mb-1"
                        >
                          Critical
                        </div>
                        <div
                          class="h5 mb-0 font-weight-bold text-gray-800"
                          id="ccritical"
                        ></div>
                      </div>
                      <div class="col-auto">
                        <i class="fas fa-bomb fa-2x text-gray-300"></i>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
              <div class="col-sm-2 mb-4 d-none" id="major">
                <div class="card border-left-warning shadow h-100 py-2">
                  <div class="card-body">
                    <div class="row no-gutters align-items-center">
                      <div class="col mr-2">
                        <div
                          class="text-xs font-weight-bold text-success text-uppercase mb-1"
                        >
                          Major
                        </div>
                        <div
                          class="h5 mb-0 font-weight-bold text-gray-800"
                          id="cmajor"
                        ></div>
                      </div>
                      <div class="col-auto">
                        <i class="fas fa-times fa-2x text-gray-300"></i>
                      </div>
                    </div>
                  </div>
                </div>
              </div>

              <div class="col-sm-2 mb-4 d-none" id="minor">
                <div class="card border-left-primary shadow h-100 py-2">
                  <div class="card-body">
                    <div class="row no-gutters align-items-center">
                      <div class="col mr-2">
                        <div
                          class="text-xs font-weight-bold text-success text-uppercase mb-1"
                        >
                          Minor
                        </div>
                        <div
                          class="h5 mb-0 font-weight-bold text-gray-800"
                          id="cminor"
                        ></div>
                      </div>
                      <div class="col-auto">
                        <i
                          class="fas fa-exclamation-circle fa-2x text-gray-300"
                        ></i>
                      </div>
                    </div>
                  </div>
                </div>
              </div>

              <div class="col-sm-2 mb-4 d-none" id="info">
                <div class="card border-left-info shadow h-100 py-2">
                  <div class="card-body">
                    <div class="row no-gutters align-items-center">
                      <div class="col mr-2">
                        <div
                          class="text-xs font-weight-bold text-success text-uppercase mb-1"
                        >
                          Information
                        </div>
                        <div
                          class="h5 mb-0 font-weight-bold text-gray-800"
                          id="cinfo"
                        ></div>
                      </div>
                      <div class="col-auto">
                        <i class="fas fa-info fa-2x text-gray-300"></i>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>
            <div class="row">
              <div class="col">
                <div class="card shadow mb-4">
                  <div class="card-header py-3">
                    <h6 class="m-0 font-weight-bold text-primary">History</h6>
                  </div>
                  <div class="card-body">
                    <div>
                      <canvas
                        class="chartjs"
                        id="historyChart"
                        style="height: 40vh"
                      ></canvas>
                    </div>
                  </div>
                </div>
              </div>
            </div>
            <!-- /.container-fluid -->
            <div class="row">
              <div class="col">
                <div class="card shadow mb-4">
                  <div class="card-header py-3">
                    <h6 class="m-0 font-weight-bold text-primary">Issues</h6>
                  </div>
                  <div class="card-body">
                    <div class="table-responsive">
                      <table
                        class="table table-bordered"
                        id="dataTable"
                        width="100%"
                        cellspacing="0"
                      >
                        <thead>
                          <tr>
                            <th>Rule</th>
                            <th>Name</th>
                            <th>Category</th>
                            <th>Severity</th>
                            <th>Categories</th>
                            <th>Message</th>
                            <th>Expected</th>
                            <th>Actual</th>
                          </tr>
                        </thead>
                        <tbody></tbody>
                        <tfoot>
                          <tr>
                            <th>Rule</th>
                            <th>Name</th>
                            <th>Category</th>
                            <th>Severity</th>
                            <th>Categories</th>
                            <th>Message</th>
                            <th>Expected</th>
                            <th>Actual</th>
                          </tr>
                        </tfoot>
                      </table>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
          <!-- End of Main Content -->

          <!-- Footer -->

          <!-- End of Footer -->
        </div>
        <!-- End of Content Wrapper -->
      </div>
    </div>
    <!-- End of Page Wrapper -->

    <!-- Scroll to Top Button-->
    <a class="scroll-to-top rounded" href="#page-top">
      <i class="fas fa-angle-up"></i>
    </a>

    <!-- Logout Modal-->
    <div
      class="modal fade"
      id="logoutModal"
      tabindex="-1"
      role="dialog"
      aria-labelledby="exampleModalLabel"
      aria-hidden="true"
    >
      <div class="modal-dialog" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="exampleModalLabel">Ready to Leave?</h5>
            <button
              class="close"
              type="button"
              data-dismiss="modal"
              aria-label="Close"
            >
              <span aria-hidden="true">×</span>
            </button>
          </div>
          <div class="modal-body">
            Select "Logout" below if you are ready to end your current session.
          </div>
          <div class="modal-footer">
            <button
              class="btn btn-secondary"
              type="button"
              data-dismiss="modal"
            >
              Cancel
            </button>
            <a class="btn btn-primary" href="login.html">Logout</a>
          </div>
        </div>
      </div>
    </div>

    <!-- Bootstrap core JavaScript-->

    <!-- Custom scripts for all Projects-->
  </body>
</html>

<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.1.1/jquery.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.4.1/js/bootstrap.bundle.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-easing/1.4.1/jquery.easing.min.js"></script>

<script
  type="text/javascript"
  src="https://cdnjs.cloudflare.com/ajax/libs/pdfmake/0.1.36/pdfmake.min.js"
></script>
<script
  type="text/javascript"
  src="https://cdnjs.cloudflare.com/ajax/libs/pdfmake/0.1.36/vfs_fonts.js"
></script>
<script
  type="text/javascript"
  src="https://cdn.datatables.net/v/dt/jszip-2.5.0/dt-1.12.1/b-2.2.3/b-colvis-2.2.3/b-html5-2.2.3/b-print-2.2.3/cr-1.5.6/fh-3.2.4/kt-2.7.0/r-2.3.0/rg-1.2.0/rr-1.2.8/sc-2.0.7/sb-1.3.4/sp-2.0.2/sl-1.4.0/datatables.min.js"
></script>

<script src="https://cdnjs.cloudflare.com/ajax/libs/Chart.js/3.8.0/chart.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/chartjs-adapter-date-fns/dist/chartjs-adapter-date-fns.bundle.min.js"></script>
<script
  src="https://cdnjs.cloudflare.com/ajax/libs/chartjs-plugin-zoom/1.2.1/chartjs-plugin-zoom.min.js"
  integrity="sha512-klQv6lz2YR+MecyFYMFRuU2eAl8IPRo6zHnsc9n142TJuJHS8CG0ix4Oq9na9ceeg1u5EkBfZsFcV3U7J51iew=="
  crossorigin="anonymous"
  referrerpolicy="no-referrer"
></script>
<script src="js/sb-admin-2.min.js"></script>

<script type="text/javascript">
  var metricsChart = {
    type: "radar",

    data: {
      datasets: [
        {
          backgroundColor: "rgba(255,99,132,0.2)",
          borderColor: "rgba(255,99,132,1)",
          pointBackgroundColor: "rgba(255,99,132,1)",
          pointBorderColor: "#fff",
          pointHoverBackgroundColor: "#fff",
          pointHoverBorderColor: "rgba(255,99,132,1)",
          data: [],
          label: "Metrics",
        },
        {
          backgroundColor: "rgba(75,192, 192, 0.2)",
          borderColor: "rgba(75, 192, 192, 1)",
          pointBackgroundColor: "rgba(75, 192, 192, 1)",
          pointBorderColor: "#fff",
          pointHoverBackgroundColor: "#fff",
          pointHoverBorderColor: "rgba(75, 192, 192, 1)",
          data: [15, 15, 15, 15, 15, 15],
          label: "Normality",
        },
      ],
      labels: [
        "proportion",
        "complexity",
        "cost",
        "documentation",
        "atomicity",
        "granularity",
      ],
    },
    options: {
      responsive: true,

      maintainAspectRatio: false,
      scale: { ticks: { beginAtZero: true } },
    },
  };
  var objectsChart = {
    type: "bar",
    data: {
      datasets: [
        {
          backgroundColor: "rgba(255,206, 86, 0.2)",
          label: "Server",
          data: [],
        },
        {
          backgroundColor: "rgba(75, 192, 192,0.2)",
          label: "Sequence",
          data: [],
        },
        {
          backgroundColor: "rgba(255, 99, 132,0.2)",
          label: "Parallel",
          data: [],
        },
      ],
      labels: [],
    },
    options: {
      legend: { position: "right" },
      scales: { x: { stacked: true }, y: { stacked: true } },
    },
  };
  var historyChart = {
    type: "bar",
    data: {
      labels: [],
      datasets: [],
    },
    options: {
      plugins: {
        title: {
          display: true,
          text: "Trends",
        },
        zoom: {
          pan: {
            enabled: true,
            modifierKey: "ctrl",
          },
          zoom: {
            wheel: {
              enabled: true,
            },
            drag: {
              enabled: true,
            },
            mode: "x",
          },
        },
      },
      responsive: true,
      maxBarThickness: 10,
      maintainAspectRatio: false,
      scales: {
        x: {
          stacked: true,
          type: "timeseries",
          ticks: {
      autoSkip: true,
      autoSkipPadding: 50,
      maxRotation: 0,
      major: {
        enabled: true
      }
    },
          time: {
            displayFormats: {
        hour: 'HH:mm',
        minute: 'HH:mm',
        second: 'HH:mm:ss'
      }
          },
        },
        y: {
          stacked: true,
        },
      },
    },
  };
  $(document).ready(function (e) {
    const queryString = window.location.search;
    const urlParams = new URLSearchParams(queryString);
    const project = urlParams.get("project");
    $("#project").text(project);
    document.title = project;
    $.getJSON("data/projects.json", function (data) {
      data.map((p) => {
        $("#projects").append(
          `<a class="collapse-item" href="issues.html?project=${p.name}">${p.name}</a>`
        );
      });
    });
    $.getJSON("data/issues.history.json", function (history) {
      const hctx = document.getElementById("historyChart").getContext("2d");
      const hChart = new Chart(hctx, historyChart);
      var data = history.filter((h) => h.project === project);

      historyChart.data.labels = data.map((d) => new Date(d.date));

      historyChart.data.datasets = [
        {
          label: "info",
          data: data.map((d) => d.issues.info),
          //stack: 'info',
          backgroundColor: "#93C3DC",
        },
        {
          label: "minor",
          data: data.map((d) => d.issues.minor),
          // stack: 'minor',
          backgroundColor: "#F8BD4F",
        },
        {
          label: "major",
          data: data.map((d) => d.issues.major),
          //  stack: 'major',
          backgroundColor: "#F58B51",
        },
        {
          label: "critical",
          data: data.map((d) => d.issues.critical),
          // stack: 'critical',
          backgroundColor: "#F65B3C",
        },
        {
          label: "blocker",
          data: data.map((d) => d.issues.blocker),
          //stack: "blocker",
          backgroundColor: "#292929",
        },
      ];
      hChart.update();
      //console.log(JSON.stringify(historyChart.data))

      $.getJSON("data/overview.history.json", function (history) {
        var data = history.filter((h) => h.project === project);
        data.map((d) => {
          historyChart.data.labels.push(new Date(d.date));
        });
        console.log(historyChart.data.labels.sort((a, b) => a - b));
        historyChart.data.datasets.push({
          label: "complexity",
          data: data.map((d) => d.metrics.complexity),
          //stack: "blocker",
          backgroundColor: "#52796f",
          borderColor: "#52796f",
          type: "line",
          stack: "complexity",
        });
        hChart.update();
        historyChart.data.datasets.push({
          label: "cost",
          data: data.map((d) => d.metrics.cost),
          //stack: "blocker",
          backgroundColor: "#84a98c",
          borderColor: "#84a98c",
          type: "line",
          stack: "cost",
        });
        hChart.update();
      });
    }).fail((f) => console.error(f));

    $.getJSON("data/" + project + ".overview.json", function (data) {
      const overview = data[0];

      $("#size").text(overview.metrics.size);
      $("#assets").text(
        Object.keys(overview.assets.assets)
          .map((i) => overview.assets.assets[i])
          .reduce((p, v) => p + v)
      );
      delete overview.metrics.size;
      metricsChart.data.datasets[0].data = Object.keys(overview.metrics).map(
        (m) => overview.metrics[m]
      );
      metricsChart.data.labels = Object.keys(overview.metrics);
      const mctx = document.getElementById("metricsChart").getContext("2d");
      const mChart = new Chart(mctx, metricsChart);
      const objects = overview.assets;
      objectsChart.data.labels = Object.keys(objects.assets);
      objectsChart.data.datasets[0].data = Object.keys(objects.assets).map(
        (m) => {
          if (!objects[m]) {
            return objects.assets[m];
          } else {
            return objects[m]["0"] || 0;
          }
        }
      );
      objectsChart.data.datasets[1].data = Object.keys(objects.assets).map(
        (m) => {
          if (!objects[m]) {
            return 0;
          } else {
            return objects[m]["2"] || 0;
          }
        }
      );
      objectsChart.data.datasets[2].data = Object.keys(objects.assets).map(
        (m) => {
          if (!objects[m]) {
            return 0;
          } else {
            return objects[m]["3"] || 0;
          }
        }
      );
      const octx = document.getElementById("objectsChart").getContext("2d");
      const oChart = new Chart(octx, objectsChart);
    });
    /*  $.getJSON("data/" + project + ".issues.json", function (issues) {
      var counters = {};
      $("#issues").text(issues.issues.length);
      var issues = issues.issues.map((i) => {
        i.categories = (i.categories || []).join(",");
        i.name = `<a href="asset.html?asset=${i.name}&project=${project}">${i.name}</a>`;
        counters[i.severity] = (counters[i.severity] || 0) + 1;
        return i;
      });

      Object.keys(counters).map((c) => {
        $("#c" + c).text(counters[c]);
        $("#" + c).removeClass("d-none");
      });*/

    var table = $("#dataTable").DataTable({
      ajax: {
        url: "data/" + project + ".issues.json",
        dataSrc: function (data) {
          var counters = {};
          var json = data.issues;
          $("#issues").text(json.length);
          for (var i = 0, ien = json.length; i < ien; i++) {
            json[
              i
            ].name = `<a href="asset.html?category=${json[i].category}&asset=${json[i].name}&project=${project}">${json[i].name}</a>`;
            json[i].categories = (json[i].categories || []).join(",");
            counters[json[i].severity] = (counters[json[i].severity] || 0) + 1;
          }
          //alert(counters.info)
          Object.keys(counters).map((c) => {
            $("#c" + c).text(counters[c]);
            $("#" + c).removeClass("d-none");
          });
          return json;
        },
        deferRender: true,
      },
      columns: [
        { data: "rule", defaultContent: "" },
        { data: "name", defaultContent: "" },
        { data: "category", defaultContent: "" },
        { data: "severity", defaultContent: "" },
        { data: "categories", defaultContent: "" },
        { data: "message", defaultContent: "" },
        { data: "expected", defaultContent: "" },
        { data: "actual", defaultContent: "" },
      ],
      fixedHeader: true,
      colReorder: true,
      dom: "BRSPfrtipl",
      buttons: [
        "colvis",
        {
          extend: "copyHtml5",
          exportOptions: {
            columns: ":visible",
          },
        },
        {
          extend: "excelHtml5",
          exportOptions: {
            columns: ":visible",
          },
        },
        {
          extend: "csvHtml5",
          exportOptions: {
            columns: ":visible",
          },
        },
        {
          extend: "pdfHtml5",
          exportOptions: {
            columns: ":visible",
          },
        },
        {
          extend: "print",
          exportOptions: {
            columns: ":visible",
          },
        },
      ],
      columnDefs: [
        {
          searchPanes: {
            show: true,
          },
          targets: [0, 1, 2, 3, 4],
        },
        {
          searchPanes: {
            show: false,
          },
          targets: [5, 6, 7],
        },
      ],
      searchPanes: {
        initCollapsed: true,
      },
      //});
    });
  });
</script>
